﻿Type=Activity
Version=3.5
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: True
	#IncludeTitle: False
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These varibles can be accessed from all modules.
	
	Dim MyTimer As Timer
	Dim MyBeeper As Beeper  'Need audio library

End Sub

Sub Globals

	Dim DisplayCounter As Label
	Dim Title As Label
	
	Dim red As ImageView
	Dim Green As ImageView
	Dim Yellow As ImageView
	
	Dim CountNum As EditText
	Dim PauseNum As EditText
	Dim Repeat As Label
	
	Dim Panel1 As Panel	
	
	Dim Plus As ImageView
	Dim PanelPlus As Panel
	Dim Minus As ImageView
	Dim PanelMinus As Panel

	Dim i As Long
	Dim t As Long
		
End Sub


Sub TimerStart
	
	i = 0 
	MyTimer.Enabled = True 
	
End Sub

Sub MyTimer_Tick   
	
	If Main.Abort Then 
		MyTimer.Enabled = False
		MyBeeper.beep
	Else
		
		DoEvents
		
		i = i + 1
		
		If Main.countUpDown = 1 Then 
			DisplayCounter.Text = 0 + i
		Else
			DisplayCounter.Text = t - i
		End If
					
		If i >= t  Then 
			MyTimer.Enabled = False
	   	End If
		
	End If
	
End Sub




Sub Activity_KeyPress (KeyCode As Int) As Boolean 'return true if you want to consume the event

	If KeyCode = KeyCodes.KEYCODE_BACK Then
		'*** Put code here To Do what you want. If you want To control what 'Back' is doing you can handle it
		'*** here (such As stopping the Beep). Then Return True If you Do Not want the system To process it
		'*** (If you don't really want to let the system go back), otherwise return False and the system will
		'*** process it normally.
		Main.Abort = True
		Return True
	Else
		Return False
	End If

End Sub 




Sub Activity_Resume
		
	MyBeeper.Initialize(300, Main.Frequency) '200 milliseconds, 500 hz
	MyTimer.Initialize("MyTimer", 1000) 
	Setup
	GreenStart

End Sub
Sub Activity_Pause (UserClosed As Boolean)
	
	MyBeeper.Release
	MyTimer.Enabled =  False
	SaveTheStuff	
	
	If UserClosed Then
		Main.ContinuousRepeat = False
		Activity.Finish
	End If
	
End Sub



Sub Activity_Create(FirstTime As Boolean)

	Try
		MyTimer.Enabled = False
	Catch
	End Try
	
	Try
		MyBeeper.Release
	Catch
	End Try

	Main.Phone1.SetScreenOrientation(Main.ScreenOrientation)

	'Load main layout file.
    Activity.LoadLayout("Main") 
		
	If FirstTime Then
		LoadTheStuff
	End If
	
End Sub


Sub GreenStart	
	
	Do While (Main.ContinuousRepeat)
		GreenGoOnce
	Loop
	
	Main.ContinuousRepeat = False
	Repeat.Text = "Repeat OFF"
	
	Repeat.Enabled = True
	
	Panel1.Enabled = True
	Panel1.Visible = True
	
	DisplayCounter.Text = "Start"
	
	Green.Enabled = True
	Green.Visible = True

	red.Enabled = False
	red.Visible = False

	Yellow.Enabled = False
	Yellow.Visible = False
	
End Sub


Sub Green_click
Dim Phone1 As Phone
	
	Phone1.HideKeyboard(Activity)
	
		PullToProgram
		
		Repeat.Enabled = False 'Visible but not active
		
		Panel1.Visible = False
		Panel1.Enabled = False
				
		Green.Enabled = False
		Green.Visible = False
		
		red.Enabled = True
		Yellow.Enabled = True

		Main.Abort = False
		
		GreenGoOnce
		GreenStart
	
End Sub
Sub GreenGoOnce
 
	If Main.CountLengthInSeconds > 0 Then
		RedRun
		If Main.Abort Then 
		Else
			If Main.PauseLengthInSeconds > 0 Then
				YellowRun
				If Main.Abort Then 
				Else
					MyBeeper.beep
				End If
			Else 
				MyBeeper.beep
			End If
		End If
	End If

End Sub

Sub Red_click

	Main.Abort = True
	Main.ContinuousRepeat = False
	Repeat.Text = "Repeat OFF"

End Sub
Sub RedRun
		
	DisplayCounter.Text = "Start"
	
	red.Visible = True
	Yellow.Visible = False
	MyBeeper.beep
		
	t = Main.CountLengthInSeconds
	TimerStart
	Do While MyTimer.Enabled
		DoEvents
	Loop
		
End Sub
Sub Yellow_click

	Main.Abort = True
	Main.ContinuousRepeat = False
	Repeat.Text = "Repeat OFF"

End Sub
Sub YellowRun
	
	DisplayCounter.Text = "Pause"

	red.Visible = False
	Yellow.Visible = True
	MyBeeper.beep

	t = Main.PauseLengthInSeconds
	TimerStart
	Do While MyTimer.Enabled
		DoEvents
	Loop

End Sub



Sub Plus_click

	Main.countUpDown = 1
	SetPlusMinusDisplay
	
End Sub
Sub Minus_click

	Main.countUpDown = -1
	SetPlusMinusDisplay
	
End Sub
Sub SetPlusMinusDisplay

	If Main.countUpDown = 1 Then
	
		Plus.Enabled = False
		Minus.Enabled = True
		
		PanelPlus.Visible = True
		PanelMinus.Visible = False
		
	Else
	
		Plus.Enabled = True
		Minus.Enabled = False
		
		PanelPlus.Visible = False
		PanelMinus.Visible = True
		
	End If

End Sub
Sub Repeat_click

	If Main.ContinuousRepeat  = True Then
		Main.ContinuousRepeat = False
		SetRepeatDisplay
	Else
		Main.ContinuousRepeat = True
		SetRepeatDisplay
	End If
	
End Sub
Sub SetRepeatDisplay

	If Main.ContinuousRepeat  = True Then
		Repeat.Text = "Repeat ON"
	Else
		Repeat.Text = "Repeat OFF"
	End If

End Sub

'Sub CountNum_FocusChanged (HasFocus As Boolean)
'
'	Try
'	   If HasFocus = False Then
'	      ' lost focus	
'	   End If
'	Catch
'		CountNum.text = Main.CountLengthInSeconds
'	End Try
'	
'	PullToProgram
'	
'End Sub
'Sub PauseNum_FocusChanged (HasFocus As Boolean)
'
'	Try
'	   If HasFocus = False Then
'	      ' lost focus	
'	   End If
'	Catch
'		PauseNum.text = Main.PauseLengthInSeconds 
'	End Try
'	
'	PullToProgram
'	
'End Sub



Sub Setup

	Title.Color = Colors.White
	Title.TextColor = Colors.Black
	
	DisplayCounter.TextColor = Colors.Black
	
	DisplayCounter.Enabled = False
	SetPlusMinusDisplay
	SetCountAndPauseToDisplay
	'Main.ContinuousRepeat = False
	
End Sub
Sub SetCountAndPauseToDisplay
	
	CountNum.text = Main.CountLengthInSeconds 
	PauseNum.text = Main.PauseLengthInSeconds

End Sub
Sub PullToProgram

	Main.CountLengthInSeconds = CountNum.text 
	Main.PauseLengthInSeconds = PauseNum.text
	SaveTheStuff
	
End Sub


Sub LoadTheStuff()

	Try
	
		Main.SaveList.Clear
		Main.SaveList = File.ReadList(File.DirInternalCache, "SportsCounter.txt")

		Dim j As Int

		j = 0
		Main.CountLengthInSeconds = Main.SaveList.get(j) 
		j = j + 1   
		Main.PauseLengthInSeconds = Main.SaveList.get(j) 		
		j = j + 1   
		Main.countUpDown = Main.SaveList.get(j) 		
		'j = j + 1   
		'Main.ContinuousRepeat = Main.SaveList.get(j) 		

	Catch
	
		'set defaults
		Main.CountLengthInSeconds = 10
		Main.PauseLengthInSeconds = 5
		Main.countUpDown  = -1
		'Main.ContinuousRepeat = False
		
	End Try
	
	'SetCountAndPauseToDisplay
	
End Sub
Sub SaveTheStuff()

	Main.SaveList.clear

	Main.SaveList.add (Main.CountLengthInSeconds) 
	Main.SaveList.add (Main.PauseLengthInSeconds) 
	Main.SaveList.add (Main.countUpDown)
	'Main.SaveList.Add (Main.ContinuousRepeat)
	
	File.Delete(File.DirInternalCache, "SportsCounter.txt")
	File.WriteList (File.DirInternalCache, "SportsCounter.txt", Main.SaveList)
	
End Sub

